#version 120

/*
Modified Chocapic13 Shader Lite By CrapdeShoes
*/


varying vec4 texcoord;
varying vec3 sunlight;
varying vec3 lightVector;
varying vec3 ambient_color;

uniform sampler2D composite;
uniform sampler2D gaux4;
uniform sampler2D gaux1;
uniform sampler2D depthtex0;
uniform sampler2D depthtex1;
uniform sampler2D gnormal;
uniform sampler2D gdepth;

uniform vec3 sunPosition;
uniform vec3 moonPosition;
uniform vec3 upPosition;
uniform vec3 cameraPosition;
uniform vec3 previousCameraPosition;
uniform vec3 skyColor;

uniform mat4 gbufferProjection;
uniform mat4 gbufferProjectionInverse;
uniform mat4 gbufferPreviousProjection;
uniform mat4 gbufferModelViewInverse;
uniform mat4 gbufferPreviousModelView;

uniform int isEyeInWater;
uniform int worldTime;
uniform float far;
uniform float near;
uniform float aspectRatio;
uniform float viewWidth;
uniform float viewHeight;
uniform float rainStrength;
uniform float wetness;
uniform float frameTimeCounter;

uniform int fogMode;

float pw = 1.0/ viewWidth;
float ph = 1.0/ viewHeight;

float matflag = texture2D(gaux1,texcoord.xy).g;
vec3 fogclr = pow(mix(vec3(0.5,0.5,1.0),vec3(0.3,0.3,0.3),rainStrength)*ambient_color,vec3(2.2));
	
vec3 fragpos = vec3(texcoord.st, texture2D(depthtex0, texcoord.st).r);	

vec4 color = texture2D(composite,texcoord.xy)*16.0;	

float ld(float depth) {
    return (2.0 * near) / (far + near - depth * (far - near));
}

float pixeldepth = texture2D(depthtex0,texcoord.xy).x;

void main() {

int land = int(matflag < 0.03);
int iswater = int(matflag > 0.04 && matflag < 0.07);
int hand  = int(matflag > 0.75 && matflag < 0.85);
	
vec3 colmult = mix(vec3(1.0),vec3(0.1,0.25,0.45),isEyeInWater);
float depth_diff = clamp(pow(ld(texture2D(depthtex0, texcoord.st).r)*3.4,2.0),0.0,1.0);

color.rgb = mix(color.rgb*colmult,vec3(0.05,0.1,0.15),depth_diff*isEyeInWater);
		
float time = float(worldTime);
float transition_fading = 1.0-(clamp((time-12000.0)/300.0,0.0,1.0)-clamp((time-13000.0)/300.0,0.0,1.0) + clamp((time-22800.0)/200.0,0.0,1.0)-clamp((time-23400.0)/200.0,0.0,1.0));
	float volumetric_cone = max(dot(normalize(fragpos),lightVector),0.0)*transition_fading;
		
float fog = exp(-pow(length(fragpos)/far,4.0-(3.0*rainStrength))*8.0);
		
float fogfactor =  clamp(fog + hand + isEyeInWater,0.0,1.0);
fogclr = mix(color.rgb,ambient_color*0.5,0.2);
color.rgb = mix(fogclr,color.rgb,fogfactor);	
		
/* DRAWBUFFERS:5 */

vec4 tpos = vec4(sunPosition,1.0)*gbufferProjection;
tpos = vec4(tpos.xyz/tpos.w,1.0);
vec2 pos1 = tpos.xy/tpos.z;
vec2 lightPos = pos1*0.5+0.5;
	
float visiblesun = 0.0;
float temp;
float nb = 0;

if (texcoord.x < pw && texcoord.x < ph) {
	for (int i = 0; i < 10;i++) {
		for (int j = 0; j < 10 ;j++) {
		temp = texture2D(gaux1,lightPos + vec2(pw*(i-5.0),ph*(j-5.0))*10.0).g;
		visiblesun +=  1.0-float(temp > 0.04) ;
		nb += 1.0;
		}
	}
	visiblesun /= nb;

}

		color = clamp(color/16.0,0.0,1.0);	

	gl_FragData[0] = vec4(color.rgb,visiblesun);
	
}